package com.bakdata.conquery.resources.admin.ui;

import static com.bakdata.conquery.resources.ResourceConstants.*;

import com.bakdata.conquery.models.datasets.Dataset;
import com.bakdata.conquery.models.datasets.Import;
import com.bakdata.conquery.models.datasets.Table;
import com.bakdata.conquery.resources.admin.rest.UIProcessor;
import com.bakdata.conquery.resources.admin.ui.model.UIView;
import io.dropwizard.views.common.View;
import jakarta.inject.Inject;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.PathParam;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.core.MediaType;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;

@Produces(MediaType.TEXT_HTML)
@Path("datasets/{" + DATASET + "}/tables/{" + TABLE + "}")
@Getter
@Setter
@Slf4j
@RequiredArgsConstructor(onConstructor_ = @Inject)
public class TablesUIResource {

	private final UIProcessor uiProcessor;

	@PathParam(DATASET)
	private Dataset dataset;
	@PathParam(TABLE)
	private Table table;


	@GET
	public View getTableView() {
		return new UIView<>(
				"table.html.ftl",
				uiProcessor.getUIContext(),
				uiProcessor.getTableStatistics(table)
		);
	}

	@GET
	@Path("import/{" + IMPORT_ID + "}")
	public View getImportView(@PathParam(IMPORT_ID) Import imp) {

		return new UIView<>(
				"import.html.ftl",
				uiProcessor.getUIContext(),
				uiProcessor.getImportStatistics(imp)
		);
	}
}